module OW_pspi

use OWvel
use OW_type
use OW_image
use OW_fftw
use OW_grabvel
use OW_parms
use OW_sumimg

implicit none

public						:: owpspi_init, owpspi
private						:: isp,ni,node,ixs

integer						:: isp,ni,node,ixs
real						:: wb

contains

!---------------------------------------------------------
subroutine owpspi_init(isp_in,ni_in,node_in,ixs_in,wb_in)

integer						:: isp_in,ni_in,node_in,ixs_in
real						:: wb_in

isp=isp_in
ni=ni_in
node=node_in
ixs=ixs_in
wb=wb_in

end subroutine
!---------------------------------------------------------
subroutine owpspi(recv,source,vel,image)

integer						:: iw,iz,ikx,iref,ixw,ish,ino,inode
integer						:: nv,ihso,nwb
real						:: sqa,f,g
real						:: minv, maxv,vel(:,:)
real, allocatable				:: vref(:),sqa0(:),vtemp(:)
complex, allocatable				:: ws(:),wr(:),gs0(:),gr0(:),gs(:,:),gr(:,:)
complex, pointer				:: tfld(:)
complex						:: recv(:,:),source(:,:,:),image(:,:,:)
complex,allocatable				:: GG(:,:,:,:)

integer, external 				:: omp_get_thread_num,omp_get_num_threads,omp_get_num_procs
!!!!!
real						:: dvel
!!!!!

allocate(GG(img%z%n,img%sh%n,rec%h%n,node))

!--------------------------------------------------
! Setting FFTW plans
!
allocate(tfld(kxm%n))
call owfftw(tfld)

!$OMP parallel default(shared) private(inode,wb,nwb) firstprivate(planF,planI,node)

inode=omp_get_thread_num()+1;
wb=floor(wb/img%z%d)*img%z%d
nwb=floor(wb/img%z%d)+1

!$OMP do private(tfld,wr,ws,gr,gs,gr0,gs0,sqa0,vtemp,vref,minv,maxv,sqa,f,g,iw,ikx,iz,iref)

omega:do iw = 1,rec%w%n


write(0,*) "passei 00",inode
allocate(wr(rec%h%n));		wr=0
allocate(ws(rec%h%n));		ws=0
allocate(gs(rec%h%n,nref));	gs=0
allocate(gr(rec%h%n,nref));	gr=0
allocate(gs0(rec%h%n));		gs0=0
allocate(gr0(rec%h%n));		gr0=0
allocate(sqa0(rec%h%n));	sqa0=0
allocate(vref(nref));		vref=0
allocate(vtemp(rec%h%n));	vtemp=0
!        if (allocated(wr)) deallocate(wr);	allocate(wr(rec%h%n));		wr=0
!        if (allocated(ws)) deallocate(ws);	allocate(ws(rec%h%n));		ws=0
!        if (allocated(gs)) deallocate(gs);	allocate(gs(rec%h%n,nref));	gs=0
!        if (allocated(gr)) deallocate(gr);	allocate(gr(rec%h%n,nref));	gr=0
!        if (allocated(gs0)) deallocate(gs0);	allocate(gs0(rec%h%n));		gs0=0
!        if (allocated(gr0)) deallocate(gr0);	allocate(gr0(rec%h%n));		gr0=0
!        if (allocated(sqa0)) deallocate(sqa0);	allocate(sqa0(rec%h%n));	sqa0=0
!        if (allocated(vref)) deallocate(vref);	allocate(vref(nref));		vref=0
!        if (allocated(vtemp)) deallocate(vtemp);allocate(vtemp(rec%h%n));	vtemp=0
write(0,*) "passei 01",inode
        ws(isp)=source(1,iw,1) ! to be modified to handle generalized sources
        wr=recv(:,iw) 
write(0,*) "passei 02",inode
        depth:do iz=nwb+1,img%z%n

!--------------------------------------------------
! Compute vref
!
            vtemp=vel(iz,:)
            call owvref(nref,vtemp,vref,minv,maxv)

write(0,*) "passei 02.5",inode
            tfld=ws; call sfftw_execute(planF); ws=tfld/sqrt(1.*kxm%n)
            tfld=wr; call sfftw_execute(planF); wr=tfld/sqrt(1.*kxm%n)
write(0,*) "passei 03",inode

           vxz:if (minv .eq. maxv) then
                gs0=ws;  gr0=wr;

!      Operations in the wavenumber domain
!      phase shift
                wavenumber1:do ikx = 1,kxm%n
                   sqa = rec%w%all(iw)**2 / minv**2 - kxm%all(ikx)**2

                   evanescent1:if (sqa > 0) then
                       gs0(ikx)=gs0(ikx)*exp(cmplx(0,v%z%d*sqrt(sqa)))
                       gr0(ikx)=gr0(ikx)*exp(cmplx(0,-v%z%d*sqrt(sqa)))
                   else
                       gs0(ikx)=gs0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                       gr0(ikx)=gr0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                   end if evanescent1
                end do wavenumber1


                   tfld=gs0; call sfftw_execute(planI); ws=tfld/sqrt(1.*kxm%n)
                   tfld=gr0; call sfftw_execute(planI); wr=tfld/sqrt(1.*kxm%n)
write(0,*) "passei 04",inode


            else
                velref: do iref=1,nref                 
                    gs(:,iref)=ws;  gr(:,iref)=wr; 
                    wavenumber2: do ikx = 1,kxm%n
!      phase shift
                        sqa = rec%w%all(iw)**2 / vref(iref)**2 - kxm%all(ikx)**2;
                        evanescent2: if (sqa > 0) then
                            gs(ikx,iref)=gs(ikx,iref)*exp(cmplx(0,v%z%d*sqrt(sqa)));
                            gr(ikx,iref)=gr(ikx,iref)*exp(cmplx(0,-v%z%d*sqrt(sqa)));
                        else
                            gs(ikx,iref)=gs(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                            gr(ikx,iref)=gr(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                        end if evanescent2
                    end do wavenumber2

!                      sqa0 = rec%w%all(iw)**2 / vref(iref)**2 - kxm%all**2;
!                      evanescent2:where (sqa0 > 0)
!                          gs(:,iref)=gs(:,iref)*exp(cmplx(0,v%z%d*sqrt(sqa0)))
!                          gr(:,iref)=gr(:,iref)*exp(cmplx(0,-v%z%d*sqrt(sqa0)))
!                      elsewhere
!                          gs(:,iref)=gs(:,iref)*exp(-sqrt(-sqa0)*v%z%d)
!                          gr(:,iref)=gr(:,iref)*exp(-sqrt(-sqa0)*v%z%d)
!                      end where evanescent2

! Operations in x            

                      tfld=gs(:,iref); call sfftw_execute(planI); gs(:,iref)=tfld/sqrt(1.*kxm%n)
                      tfld=gr(:,iref); call sfftw_execute(planI); gr(:,iref)=tfld/sqrt(1.*kxm%n)

write(0,*) "passei 05",inode

 !      split step
                      gs(:,iref) = gs(:,iref) * exp(cmplx(0,v%z%d*rec%w%all(iw))*(1./vel(iz,:)-1./vref(iref)));
                      gr(:,iref) = gr(:,iref) * exp(cmplx(0,-v%z%d*rec%w%all(iw))*(1./vel(iz,:)-1./vref(iref)));
                end do velref

!                do iref=1,nref-1
!                interpwvfld: where (vel(iz,:) >= vref(iref) .and. vel(iz,:) < vref(iref+1))
!                     ws=gs(:,iref)
!                     wr=gr(:,iref)
!                     end where interpwvfld
!                end do
!                where (vel(iz,:) >= vref(nref))
!                      ws=gs(:,nref)
!                      wr=gr(:,nref)
!                end where

                do ikx=1,kxm%n
                    do iref=1,nref-1
                        if (vref(iref) .ne. vref(iref+1)) then
                            if (vel(iz,ikx) >= vref(iref) .and. vel(iz,ikx) < vref(iref+1)) then
                                f=(vel(iz,ikx) - vref(iref))/vel(iz,ikx)
                                g=1-f
                                ws(ikx)=g*gs(ikx,iref)+f*gs(ikx,iref+1)
                                wr(ikx)=g*gr(ikx,iref)+f*gr(ikx,iref+1)
!                                ws(ikx)=gs(ikx,iref)
!                                wr(ikx)=gr(ikx,iref)
                            elseif (vel(iz,ikx) >= vref(nref)) then
                                ws(ikx)=gs(ikx,nref)
                                wr(ikx)=gr(ikx,nref)
                            end if
                        else
                            ws(ikx)=gs(ikx,iref)
                            wr(ikx)=gr(ikx,iref)
                        end if                            
                    end do
                end do
           end if vxz
write(0,*) "passei 06",inode

           call owimage_init(ni)
           call owimage(ws,wr,GG(iz,:,:,inode))
write(0,*) "passei 07",inode

        end do depth
        if (mod(iw,10)==1) write(0,5) "FROM NODE: ",inode," FREQUENCY # ",iw," OUT OF ",rec%w%n," / SHOT # ",ixs
5                          format(A11,i3,A13,i5,2(A8,i5))

!if (allocated(wr)) deallocate(wr)
!if (allocated(gs)) deallocate(gs)
!if (allocated(gr)) deallocate(gr)
!if (allocated(gs0)) deallocate(gs0)
!if (allocated(gr0)) deallocate(gr0)
!if (allocated(sqa0)) deallocate(sqa0)
!if (allocated(vref)) deallocate(vref)
!if (allocated(vtemp)) deallocate(vtemp)
end do omega
!$OMP end do
!$OMP end parallel

call owsum_img_init(ni,node)
call owsum_img(GG,image)

end subroutine owpspi

end module
